local NedStark = LibStub("AceAddon-3.0"):NewAddon("NedStark", "AceConsole-3.0", "AceEvent-3.0", "AceConsole-3.0")
local L = LibStub('AceLocale-3.0'):GetLocale('NedStark', true)
local AceConfig = LibStub("AceConfig-3.0")
local AceGUI = LibStub("AceGUI-3.0")

local defaults = {
	char = {
		enabled=true,
	},
}

local NedStark_Frame = nil

function NedStark:OnInitialize()
	NedStark.db = LibStub("AceDB-3.0"):New("NedStarkDB", defaults)
	NedStark.version = GetAddOnMetadata("NedStark", "Version")
end

function NedStark:OnEnable()
	NedStark:RegisterChatCommand("ns", "OnSlashCommand")
	if NedStark.db.char.enabled == true then
		NedStark:RegisterEvent("TALKINGHEAD_REQUESTED")
	end
end

function NedStark:OnSlashCommand(input)
	local command, rest = input:match("^(%S*)%s*(.-)$")

	if command == "enable" then
		if NedStark.db.char.enabled == false then
			NedStark.db.char.enabled = true

			NedStark:RegisterEvent("TALKINGHEAD_REQUESTED")

			ns_print('enabled.')
		else
			ns_print('is already enabled.')
		end
	elseif command == "disable" then
		if NedStark.db.char.enabled == true then
			NedStark.db.char.enabled = false

			NedStark:UnregisterEvent("TALKINGHEAD_REQUESTED")

			ns_print('disabled.')
		else
			ns_print('is already disabled.')
		end
	else
		ns_print("Syntax: /ns enable, /ns disable")
	end
end

function NedStark:TALKINGHEAD_REQUESTED(event)
	local SFXCVar = GetCVar("Sound_EnableDialog")
	if SFXCVar == "1" then
		SetCVar("Sound_EnableDialog", 0);
	end

	if ( TalkingHeadFrame and TalkingHeadFrame:IsShown() ) then
		NedStark_TalkingHeadFrame_CloseImmediately()
	else
		if TalkingHeadFrame then
			if not TalkingHeadFrame:IsShown() then
				if TalkingHeadFrame then
					if ( TalkingHeadFrame.voHandle ) then
						StopSound(TalkingHeadFrame.voHandle);
						TalkingHeadFrame.voHandle = nil;
					end
				end
				C_Timer.After(0.1, NedStark_TalkingHeadFrame_CloseImmediately)
			end
		end
	end
end

function NedStark_TalkingHeadFrame_CloseImmediately()
	local frame = TalkingHeadFrame;
	if ( frame and frame:IsShown() ) then
		if (frame.finishTimer) then
			frame.finishTimer:Cancel();
			frame.finishTimer = nil;
		end
		C_TalkingHead.IgnoreCurrentTalkingHead();
		frame:Hide();
		if ( frame.voHandle ) then
			StopSound(frame.voHandle);
			frame.voHandle = nil;
		end
		local SFXCVar = GetCVar("Sound_EnableDialog")
		if SFXCVar == "0" then
			C_Timer.After(3, function()
				SetCVar("Sound_EnableDialog", 1)
			end)
		end
	else
		C_Timer.After(0.1, function() NedStark_TalkingHeadFrame_CloseImmediately() end)
	end
end

function ns_print(s)
	DEFAULT_CHAT_FRAME:AddMessage('NedStark: ' .. '|cFFFFFFFF' .. s, 0.90, 0, 0)
end
